![Logo](https://github.com/psambit9791/jdsp/blob/master/res/img/JDSP-Logo-Inverted.png#gh-dark-mode-only)
![Logo](https://github.com/psambit9791/jdsp/blob/master/res/img/JDSP-Logo.png#gh-light-mode-only)


[![Build Status](https://travis-ci.com/psambit9791/jdsp.svg?branch=master)](https://app.travis-ci.com/psambit9791/jdsp)
[![codecov](https://codecov.io/gh/psambit9791/jdsp/branch/master/graph/badge.svg)](https://codecov.io/gh/psambit9791/jdsp)
[![Maven Central](https://img.shields.io/maven-central/v/com.github.psambit9791/jdsp.svg?label=Maven%20Central)](https://search.maven.org/search?q=g:%22com.github.psambit9791%22%20AND%20a:%22jdsp%22)
[![javadoc](https://javadoc.io/badge2/com.github.psambit9791/jdsp/javadoc.svg)](https://javadoc.io/doc/com.github.psambit9791/jdsp)
[![jitpack](https://jitpack.io/v/psambit9791/jdsp.svg)](https://jitpack.io/#psambit9791/jdsp)
[![License: MIT](https://img.shields.io/badge/License-MIT-blue.svg?)](https://github.com/psambit9791/jdsp/blob/master/LICENSE)
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.3903921.svg)](https://doi.org/10.5281/zenodo.3903921)

JDSP is a library of signal processing tools aimed at providing functionalities as available in MATLAB or in scipy-signal package for 
Python. The goal is to provide easy-to-use APIs for performing complex operation on signals eliminating the necessity 
of understanding the low-level complexities in the processing pipeline.  

## Quick Start

<br/>

To get the latest stable release of JDSP:

### Gradle
```
implementation 'com.github.psambit9791:jdsp:2.0.1'
```

### Maven
```
<dependency>
  <groupId>com.github.psambit9791</groupId>
  <artifactId>jdsp</artifactId>
  <version>2.0.1</version>
</dependency>
```

<br/>

For the latest development version of JDSP:

### Github
```  
git clone --single-branch --branch master https://github.com/psambit9791/jdsp.git
``` 

### JitPack
You can use **JitPack** to use the development version on your application; use this [link](https://jitpack.io/#psambit9791/jdsp/master-SNAPSHOT) for reference.
<br/>

## Documentation

See the [**Wiki**](https://github.com/psambit9791/jdsp/wiki) for an introduction to the general use of JDSP.

See the [**javadocs**](https://javadoc.io/doc/com.github.psambit9791/jdsp) for more detailed documentation.

<br/>

## Citation

If you are using this software in your research, please use the following citation:

```
@software{sambit_paul_2023_7675362,
  author       = {Sambit Paul and
                  Sibo Van Gool},
  title        = {psambit9791/jdsp: v2.0.1 (February 24, 2023)},
  month        = feb,
  year         = 2023,
  publisher    = {Zenodo},
  version      = {v2.0.1},
  doi          = {10.5281/zenodo.7675362},
  url          = {https://doi.org/10.5281/zenodo.7675362}
}
```

<br/>

## Usage

| **Class** 		                                                                                                                                                                                               | **Type**		                                                                                                                                      | **Description**	                                                                                                        |
|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|-------------------------------------------------------------------------------------------------------------------------------------------------|-------------------------------------------------------------------------------------------------------------------------|
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/filter/Butterworth.html">com.github.psambit9791.jdsp.filter.Butterworth</a>                                 | <a href="https://github.com/psambit9791/jdsp/wiki/Butterworth-Filter">IIR <strong>Filter</strong></a>                                           | Implements Butterworth Filter for low-pass, high-pass, band-pass and band-stop operation                                |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/filter/Chebyshev.html">com.github.psambit9791.jdsp.filter.Chebyshev</a>                                     | <a href="https://github.com/psambit9791/jdsp/wiki/Chebyshev-Filter">IIR <strong>Filter</strong></a>                                             | Implements Chebyshev Filter (Type 1 and Type 2) for low-pass, high-pass, band-pass and band-stop operation              |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/filter/Bessel.html">com.github.psambit9791.jdsp.filter.Bessel</a>                                           | <a href="https://github.com/psambit9791/jdsp/wiki/Bessel-Filter">IIR <strong>Filter</strong></a>                                                | Implements Bessel Filter for low-pass, high-pass, band-pass and band-stop operation                                     |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/filter/Butterworth.html">com.github.psambit9791.jdsp.filter.FIRWin1</a>                                     | <a href="https://github.com/psambit9791/jdsp/wiki/Windowed-FIR">FIR <strong>Filter</strong></a>                                                 | Implements a windowed FIR filter for low-pass, high-pass, band-pass and band-stop operation                             |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/filter/Chebyshev.html">com.github.psambit9791.jdsp.filter.FIRWin2</a>                                       | <a href="https://github.com/psambit9791/jdsp/wiki/Windowed-FIR-with-Gain">FIR <strong>Filter</strong></a>                                       | Implements a windowed FIR filter (with gain) for low-pass, high-pass, band-pass and band-stop operation                 |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/filter/Bessel.html">com.github.psambit9791.jdsp.filter.FIRLS</a>                                            | <a href="https://github.com/psambit9791/jdsp/wiki/FIR-Least-Squares">FIR <strong>Filter</strong></a>                                            | Implements an FIR filter which has the closest frequency response as desired optimised using Least Squares Minimization |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/filter/Median.html">com.github.psambit9791.jdsp.filter.Median</a>                                           | <a href="https://github.com/psambit9791/jdsp/wiki/Kernel-Based-Filter">Kernel-based <strong>Filter</strong></a>                                 | Implements Median Filter for smoothing while maintaining the sharp edges                                                |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/filter/Savgol.html">com.github.psambit9791.jdsp.filter.Savgol</a>                                           | <a href="https://github.com/psambit9791/jdsp/wiki/Kernel-Based-Filter">Kernel-based <strong>Filter</strong></a>                                 | Implements Savitzky–Golay Filter for smoothing using Savitzky–Golay coefficients                                        |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/filter/Wiener.html">com.github.psambit9791.jdsp.filter.Wiener</a>                                           | <a href="https://github.com/psambit9791/jdsp/wiki/Kernel-Based-Filter">Kernel-based <strong>Filter</strong></a>                                 | Implements Wiener Filter for the sharpening operation                                                                   |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/filter/adaptive/AP.html">com.github.psambit9791.jdsp.filter.adaptive.AP</a>                                 | <a href="https://github.com/psambit9791/jdsp/wiki/Affine-Projection-Adaptive-Filter">Adaptive <strong>Filter</strong></a>                       | Implements Affine Projection Adaptive filter                                                                            |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/filter/adaptive/GNGD.html">com.github.psambit9791.jdsp.filter.adaptive.GNGD</a>                             | <a href="https://github.com/psambit9791/jdsp/wiki/Generalised-Normalised-Gradient-Descent-Adaptive-Filter">Adaptive <strong>Filter</strong></a> | Implements Generalised Normalised Gradient Descent Adaptive Filter Adaptive filter                                      |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/filter/adaptive/LMS.html">com.github.psambit9791.jdsp.filter.adaptive.LMS</a>                               | <a href="https://github.com/psambit9791/jdsp/wiki/Least-Mean-Squares-Adaptive-Filter">Adaptive <strong>Filter</strong></a>                      | Implements Least Mean Squares Adaptive filter                                                                           |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/filter/adaptive/NLMS.html">com.github.psambit9791.jdsp.filter.adaptive.NLMS</a>                             | <a href="https://github.com/psambit9791/jdsp/wiki/Noamalised-Least-Mean-Squares-Adaptive-Filter">Adaptive <strong>Filter</strong></a>           | Implements Normalised Least Mean Squares Adaptive filter                                                                |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/filter/adaptive/RLS.html">com.github.psambit9791.jdsp.filter.adaptive.RLS</a>                               | <a href="https://github.com/psambit9791/jdsp/wiki/Reduced-Least-Squares-Adaptive-Filter">Adaptive <strong>Filter</strong></a>                   | Implements Reduced Least Squares Adaptive filter                                                                        |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/filter/adaptive/SSLMS.html">com.github.psambit9791.jdsp.filter.adaptive.SSLMS</a>                           | <a href="https://github.com/psambit9791/jdsp/wiki/Sign-Sign-Least-Mean-Squares-Adaptive-Filter">Adaptive <strong>Filter</strong></a>            | Implements Sign-Sign Least Mean Squares Adaptive filter                                                                 |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/filter/adaptive/NSSLMS.html">com.github.psambit9791.jdsp.filter.adaptive.NSSLMS</a>                         | <a href="https://github.com/psambit9791/jdsp/wiki/Normalised-Sign-Sign-Least-Mean-Squares-Adaptive-Filter">Adaptive <strong>Filter</strong></a> | Implements Normalised Sign-Sign Least Mean Squares Adaptive filter                                                      |
|                                                                                                                                                                                                            |                                                                                                                                                 |                                                                                                                         |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/signal/Convolution.html">com.github.psambit9791.jdsp.signal.Convolution </a>                                | <a href="https://github.com/psambit9791/jdsp/wiki/Convolution-&-Cross-Correlation"><strong>Signal</strong> Operation</a>                        | Implements the convolve() and convolve1d() operation                                                                    |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/signal/CrossCorrelation.html">com.github.psambit9791.jdsp.signal.CrossCorrelation</a>                       | <a href="https://github.com/psambit9791/jdsp/wiki/Convolution-&-Cross-Correlation"><strong>Signal</strong> Operation</a>                        | Implements the cross-correlation operation                                                                              |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/signal/Deconvolution.html">com.github.psambit9791.jdsp.signal.Deconvolution </a>                            | <a href="https://github.com/psambit9791/jdsp/wiki/Deconvolution"><strong>Signal</strong> Operation</a>                                          | Implements the deconvolution operation for valid and full mode convolved signals                                        |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/signal/Detrend.html">com.github.psambit9791.jdsp.signal.Detrend</a>                                         | <a href="https://github.com/psambit9791/jdsp/wiki/Detrend"><strong>Signal</strong> Operation</a>                                                | Implements the detrend operation to remove trends from a signal                                                         |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/signal/Smooth.html">com.github.psambit9791.jdsp.signal.Smooth</a>                                           | <a href="https://github.com/psambit9791/jdsp/wiki/Smooth"><strong>Signal</strong> Operation</a>                                                 | Implements convolutional smoothing with rectangular and triangular window                                               |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/signal/Decimate.html">com.github.psambit9791.jdsp.signal.Decimate</a>                                       | <a href="https://github.com/psambit9791/jdsp/wiki/Decimate"><strong>Signal</strong> Operation</a>                                               | Implements the decimation operation to downsample a signal after applying an anti-aliasing filter                       |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/signal/Resample.html">com.github.psambit9791.jdsp.signal.Resample</a>                                       | <a href="https://github.com/psambit9791/jdsp/wiki/Resample"><strong>Signal</strong> Operation</a>                                               | Implements the resampling operation to change the number of samples in a signal using Fourier method                    |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/signal/Generate.html">com.github.psambit9791.jdsp.signal.Generate</a>                                       | <a href="https://github.com/psambit9791/jdsp/wiki/Generate"><strong>Signal</strong> Operation</a>                                               | Helps to generate different waves and wavelets                                                                          |
|                                                                                                                                                                                                            |                                                                                                                                                 |                                                                                                                         |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/signal/peaks/FindPeak.html">com.github.psambit9791.jdsp.signal.peaks.FindPeak</a>                           | <a href="https://github.com/psambit9791/jdsp/wiki/Peak-&-Trough-Detection-and-Filtering"><strong>Peak</strong> Detection</a>                    | Identifies peaks in the signal                                                                                          |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/signal/peaks/Peak.html">com.github.psambit9791.jdsp.signal.peaks.Peak</a>                                   | <a href="https://github.com/psambit9791/jdsp/wiki/Peak-&-Trough-Detection-and-Filtering"><strong>Peak</strong> Detection</a>                    | Calculates peak properties and allows filtering with them                                                               |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/signal/peaks/Spike.html">com.github.psambit9791.jdsp.signal.peaks.Spike</a>                                 | <a href="https://github.com/psambit9791/jdsp/wiki/Spike-Detection-and-Filtering"><strong>Peak</strong> Detection</a>                            | Calculates spike properties and allows filtering with them                                                              |
|                                                                                                                                                                                                            |                                                                                                                                                 |                                                                                                                         |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/DiscreteFourier.html">com.github.psambit9791.jdsp.transform.DiscreteFourier</a>                   | <a href="https://github.com/psambit9791/jdsp/wiki/Fourier-Transforms"><strong>Transformation</strong></a>                                       | Applies the Discrete Fourier Transform on a signal                                                                      |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/InverseDiscreteFourier.html">com.github.psambit9791.jdsp.transform.InverseDiscreteFourier</a>     | <a href="https://github.com/psambit9791/jdsp/wiki/Fourier-Transforms"><strong>Transformation</strong></a>                                       | Applies the Inverse Discrete Fourier Transform on a sequence and returns the original signal                            |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/FastFourier.html">com.github.psambit9791.jdsp.transform.FastFourier</a>                           | <a href="https://github.com/psambit9791/jdsp/wiki/Fourier-Transforms"><strong>Transformation</strong></a>                                       | Applies the Fast Fourier Transform on a signal                                                                          |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/InverseFastFourier.html">com.github.psambit9791.jdsp.transform.InverseFastFourier</a>             | <a href="https://github.com/psambit9791/jdsp/wiki/Fourier-Transforms"><strong>Transformation</strong></a>                                       | Applies the Inverse Fast Fourier Transform on a sequence and returns the original signal                                |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/DiscreteSine.html">com.github.psambit9791.jdsp.transform.DiscreteSine</a>                         | <a href="https://github.com/psambit9791/jdsp/wiki/Sine-Transforms"><strong>Transformation</strong></a>                                          | Applies the Discrete Sine Transform on a signal                                                                         |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/InverseDiscreteSine.html">com.github.psambit9791.jdsp.transform.InverseDiscreteSine</a>           | <a href="https://github.com/psambit9791/jdsp/wiki/Sine-Transforms"><strong>Transformation</strong></a>                                          | Applies the Inverse Discrete Sine Transform on a sequence and returns the original signal                               |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/FastSine.html">com.github.psambit9791.jdsp.transform.FastSine</a>                                 | <a href="https://github.com/psambit9791/jdsp/wiki/Sine-Transforms"><strong>Transformation</strong></a>                                          | Applies the Fast Sine Transform on a signal                                                                             |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/InverseFastSine.html">com.github.psambit9791.jdsp.transform.InverseFastSine</a>                   | <a href="https://github.com/psambit9791/jdsp/wiki/Sine-Transforms"><strong>Transformation</strong></a>                                          | Applies the Inverse Fast Sine Transform on a sequence and returns the original signal                                   |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/DiscreteCosine.html">com.github.psambit9791.jdsp.transform.DiscreteCosine</a>                     | <a href="https://github.com/psambit9791/jdsp/wiki/Cosine-Transforms"><strong>Transformation</strong></a>                                        | Applies the Discrete Cosine Transform on a signal                                                                       |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/InverseDiscreteCosine.html">com.github.psambit9791.jdsp.transform.InverseDiscreteCosine</a>       | <a href="https://github.com/psambit9791/jdsp/wiki/Cosine-Transforms"><strong>Transformation</strong></a>                                        | Applies the Inverse Discrete Cosine Transform on a sequence and returns the original signal                             |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/FastCosine.html">com.github.psambit9791.jdsp.transform.FastCosine</a>                             | <a href="https://github.com/psambit9791/jdsp/wiki/Cosine-Transforms"><strong>Transformation</strong></a>                                        | Applies the Fast Cosine Transform on a signal                                                                           |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/InverseFastCosine.html">com.github.psambit9791.jdsp.transform.InverseFastCosine</a>               | <a href="https://github.com/psambit9791/jdsp/wiki/Cosine-Transforms"><strong>Transformation</strong></a>                                        | Applies the Inverse Fast Cosine Transform on a sequence and returns the original signal                                 |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/Hilbert.html">com.github.psambit9791.jdsp.transform.Hilbert</a>                                   | <a href="https://github.com/psambit9791/jdsp/wiki/Hilbert-Transform"><strong>Transformation</strong></a>                                        | Applies the Hilbert Transform on a signal and provides functions to return amplitude, phase and frequency information   |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/PCA.html">com.github.psambit9791.jdsp.transform.PCA</a>                                           | <a href="https://github.com/psambit9791/jdsp/wiki/Principal-Component-Analysis"><strong>Transformation</strong></a>                             | Applies Principal Component Analysis on a multi-channel signal and returns a low-dimensional signal                     |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/ICA.html">com.github.psambit9791.jdsp.transform.ICA</a>                                           | <a href="https://github.com/psambit9791/jdsp/wiki/Independent-Component-Analysis"><strong>Transformation</strong></a>                           | Performs Independent Component Analysis on a multi-channel signal and returns the recovered source signals              |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/ContinuousWavelet.html">com.github.psambit9791.jdsp.transform.ContinuousWavelet</a>               | <a href="https://github.com/psambit9791/jdsp/wiki/Continuous-Wavelet-Transforms"><strong>Transformation</strong></a>                            | Applies the Wavelet Transform on a signal with one of Paul, Ricker or Morlet wavelet                                    |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/InverseContinuousWavelet.html">com.github.psambit9791.jdsp.transform.InverseContinuousWavelet</a> | <a href="https://github.com/psambit9791/jdsp/wiki/Continuous-Wavelet-Transforms"><strong>Transformation</strong></a>                            | Applies the Inverse Wavelet Transform on a sequence transformed using CWT and returns the original signal               |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/ShortTimeFourier.html">com.github.psambit9791.jdsp.transform.ShortTimeFourier</a>                 | <a href="https://github.com/psambit9791/jdsp/wiki/Short-Time-Fourier-Transforms"><strong>Transformation</strong></a>                            | Applies the Short Time Fourier Transform on a signal                                                                    |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/transform/InverseShortTimeFourier.html">com.github.psambit9791.jdsp.transform.InverseShortTimeFourier</a>   | <a href="https://github.com/psambit9791/jdsp/wiki/Short-Time-Fourier-Transforms"><strong>Transformation</strong></a>                            | Applies the Inverse Short Time Fourier Transform on a sequence transformed using STFT and returns the original signal   |
|                                                                                                                                                                                                            |                                                                                                                                                 |                                                                                                                         |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/speech/Silence.html">com.github.psambit9791.jdsp.speech.Silence</a>                                         | <a href="https://github.com/psambit9791/jdsp/wiki/Silence"><strong>Speech</strong></a>                                                          | Provides methods to detect periods of silence in an audio                                                               |
|                                                                                                                                                                                                            |                                                                                                                                                 |                                                                                                                         |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/windows/Boxcar.html">com.github.psambit9791.jdsp.windows.Boxcar</a>                                         | <a href="https://github.com/psambit9791/jdsp/wiki/Boxcar-Window"><strong>Windowing</strong></a>                                                 | Generates a Boxcar (Rectangular) Window                                                                                 |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/windows/GeneralCosine.html">com.github.psambit9791.jdsp.windows.GeneralCosine</a>                           | <a href="https://github.com/psambit9791/jdsp/wiki/General-Cosine-Window"><strong>Windowing</strong></a>                                         | Generates a General Cosine Window with provided weights                                                                 |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/windows/Hamming.html">com.github.psambit9791.jdsp.windows.Hamming</a>                                       | <a href="https://github.com/psambit9791/jdsp/wiki/Hamming-Window"><strong>Windowing</strong></a>                                                | Generates a Hamming Window                                                                                              |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/windows/Hanning.html">com.github.psambit9791.jdsp.windows.Hanning</a>                                       | <a href="https://github.com/psambit9791/jdsp/wiki/Hanning-Window"><strong>Windowing</strong></a>                                                | Generates a Hanning Window                                                                                              |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/windows/Blackman.html">com.github.psambit9791.jdsp.windows.Blackman</a>                                     | <a href="https://github.com/psambit9791/jdsp/wiki/Blackman-Window"><strong>Windowing</strong></a>                                               | Generates a Blackman Window                                                                                             |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/windows/BlackmanHarris.html">com.github.psambit9791.jdsp.windows.BlackmanHarris</a>                         | <a href="https://github.com/psambit9791/jdsp/wiki/Blackman-Harris-Window"><strong>Windowing</strong></a>                                        | Generates a Blackman-Harris Window                                                                                      |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/windows/Poisson.html">com.github.psambit9791.jdsp.windows.Poisson</a>                                       | <a href="https://github.com/psambit9791/jdsp/wiki/Poisson-Window"><strong>Windowing</strong></a>                                                | Generates a Poisson (Exponential) Window                                                                                |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/windows/Gaussian.html">com.github.psambit9791.jdsp.windows.Gaussian</a>                                     | <a href="https://github.com/psambit9791/jdsp/wiki/Gaussian-Window"><strong>Windowing</strong></a>                                               | Generates a Gaussian Window                                                                                             |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/windows/FlatTop.html">com.github.psambit9791.jdsp.windows.FlatTop</a>                                       | <a href="https://github.com/psambit9791/jdsp/wiki/Flat-Top-Window"><strong>Windowing</strong></a>                                               | Generates a Flat Top Window                                                                                             |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/windows/Nuttall.html">com.github.psambit9791.jdsp.windows.Nuttall</a>                                       | <a href="https://github.com/psambit9791/jdsp/wiki/Nuttall-Window"><strong>Windowing</strong></a>                                                | Generates a Nuttall Window                                                                                              |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/windows/Triangular.html">com.github.psambit9791.jdsp.windows.Triangular</a>                                 | <a href="https://github.com/psambit9791/jdsp/wiki/Triangular-Window"><strong>Windowing</strong></a>                                             | Generates a Triangular Window                                                                                           |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/windows/Tukey.html">com.github.psambit9791.jdsp.windows.Tukey</a>                                           | <a href="https://github.com/psambit9791/jdsp/wiki/Tukey-Window"><strong>Windowing</strong></a>                                                  | Generates a Tukey Window                                                                                                |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/windows/Bartlett.html">com.github.psambit9791.jdsp.windows.Bartlett</a>                                     | <a href="https://github.com/psambit9791/jdsp/wiki/Bartlett-Window"><strong>Windowing</strong></a>                                               | Generates a Bartlett Window                                                                                             |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/windows/BartlettHann.html">com.github.psambit9791.jdsp.windows.BartlettHann</a>                             | <a href="https://github.com/psambit9791/jdsp/wiki/Bartlett-Hann-Window"><strong>Windowing</strong></a>                                          | Generates a Bartlett-Hann Window                                                                                        |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/windows/Bohman.html">com.github.psambit9791.jdsp.windows.Bohman</a>                                         | <a href="https://github.com/psambit9791/jdsp/wiki/Bohman-Window"><strong>Windowing</strong></a>                                                 | Generates a Bohman Window                                                                                               |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/windows/Kaiser.html">com.github.psambit9791.jdsp.windows.Kaiser</a>                                         | <a href="https://github.com/psambit9791/jdsp/wiki/Kaiser-Window"><strong>Windowing</strong></a>                                                 | Generates a Kaiser Window                                                                                               |
|                                                                                                                                                                                                            |                                                                                                                                                 |                                                                                                                         |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/splines/AkimaSpline.html">com.github.psambit9791.jdsp.splines.AkimaSpline</a>                               | <a href="https://github.com/psambit9791/jdsp/wiki/Akima-Spline"><strong>Splines</strong></a>                                                    | Provides methods to construct an Akima Spline                                                                           |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/splines/BSpline.html">com.github.psambit9791.jdsp.splines.BSpline</a>                                       | <a href="https://github.com/psambit9791/jdsp/wiki/B-Spline"><strong>Splines</strong></a>                                                        | Provides methods to construct an B-Spline                                                                               |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/splines/QuadraticSpline.html">com.github.psambit9791.jdsp.splines.QuadraticSpline</a>                       | <a href="https://github.com/psambit9791/jdsp/wiki/Quadratic-Spline"><strong>Splines</strong></a>                                                | Provides methods to construct an Quadratic B-Spline                                                                     |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/splines/CubicSpline.html">com.github.psambit9791.jdsp.splines.CubicSpline</a>                               | <a href="https://github.com/psambit9791/jdsp/wiki/Cubic-Spline"><strong>Splines</strong></a>                                                    | Provides methods to construct an Cubic B-Spline                                                                         |
|                                                                                                                                                                                                            |                                                                                                                                                 |                                                                                                                         |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/io/Wav.html">com.github.psambit9791.jdsp.io.Wav</a>                                                         | <a href="https://github.com/psambit9791/jdsp/wiki/WAV-File-IO"><strong>Input/Output</strong></a>                                                | Provides methods to read from and write to WAV files                                                                    |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/io/Csv.html">com.github.psambit9791.jdsp.io.Csv</a>                                                         | <a href="https://github.com/psambit9791/jdsp/wiki/CSV-File-IO"><strong>Input/Output</strong></a>                                                | Provides methods to read from and write to CSV files                                                                    |
|                                                                                                                                                                                                            |                                                                                                                                                 |                                                                                                                         |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/misc/UtilMethods.html">com.github.psambit9791.jdsp.misc.UtilMethods</a>                                     | <a href="https://github.com/psambit9791/jdsp/wiki/Utilities"><strong>Miscellaneous</strong></a>                                                 | Provides Numpy style utility functions, details in Wiki                                                                 |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/misc/Plotting.html">com.github.psambit9791.jdsp.misc.Plotting</a>                                           | <a href="https://github.com/psambit9791/jdsp/wiki/Plotting"><strong>Miscellaneous</strong></a>                                                  | Enables plotting of different signals and points using line and scatter plots                                           |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/misc/Polynomial.html">com.github.psambit9791.jdsp.misc.Polynomial</a>                                       | <a href="https://github.com/psambit9791/jdsp/wiki/Polynomial"><strong>Miscellaneous</strong></a>                                                | Provides methods for operating with polynomial functions                                                                |
| <a href="https://javadoc.io/doc/com.github.psambit9791/jdsp/latest/com/github/psambit9791/jdsp/misc/Random.html">com.github.psambit9791.jdsp.misc.Random</a>                                               | <a href="https://github.com/psambit9791/jdsp/wiki/Random"><strong>Miscellaneous</strong></a>                                                    | Provides methods to create random numbers as samples or multi-dimensional arrays                                        |
<br/>

## Supporting JDSP

JDSP is an open source project. <br/> You can help by becoming a sponsor on <a href="https://patreon.com/sambitpaul">Patreon</a> or doing a one time donation on <a href="https://paypal.me/psambit9791">PayPal</a>. <br />
You can also show your appreciation on <a href="https://ko-fi.com/sambitpaul">Ko-Fi</a>.<br />

<a href="https://patreon.com/sambitpaul" target="_blank"><img src="https://github.com/psambit9791/jdsp/blob/master/res/button/patron-button.png" alt="Become a Patron" /> </a>
&emsp;
<a href="https://paypal.me/psambit1412?country.x=GB&locale.x=en_GB" target="_blank"><img src="https://github.com/psambit9791/jdsp/blob/master/res/button/paypal-button.png" alt="Donate on Paypal" /> </a>
&emsp;
<a href="https://ko-fi.com/sambitpaul" target="_blank"><img src="https://github.com/psambit9791/jdsp/blob/master/res/button/kofi-button.png" alt="Support on Kofi" /> </a>

<br/>

## License
  
This project is licensed under the MIT License - see the [LICENSE](LICENSE) file for details. <br/> 
You are free to use, modify and distribute this software, as long as the copyright header is left intact.